Index: /trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 8313)
@@ -1147,12 +1114,5 @@
     public synchronized void message(GShellEvent event) {
     }
-    /** Called whenever the metadata value changes in some way, such as the addition of a new value. We want to mark the collection so that it needs saving again.
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
-     * @see org.greenstone.gatherer.collection.Collection
-     */
-    public void metadataChanged(MSMEvent event) {
-	// Again this change means we need to save the collection again.
-	collection.setSaved(false);
-    }
+
     /** This call is fired whenever a process within a GShell created by this class begins.
      * @param event A <strong>GShellEvent</strong> containing information about the GShell process.
@@ -1282,4 +1242,28 @@
 	return file;
     }
+
+
+    public void removeMetadataSet(MetadataSet metadata_set)
+    {
+	System.err.println("Removing metadata set...");
+
+	// Delete the .mds file from the collection's "metadata" folder...
+	File metadata_set_file = metadata_set.getMetadataSetFile();
+
+	// ...but not if it is the "ex.mds" file
+	if (metadata_set_file.getName().equals("ex.mds")) {
+	    return;
+	}
+
+	// ...and only if it exists
+	if (metadata_set_file.exists()) {
+	    metadata_set_file.delete();
+
+	    // Unload it from the MetadataSetManager
+	    MetadataSetManager.unloadMetadataSet(metadata_set);
+	}
+    }
+
+
     /** Used to check whether all open collections have a 'saved' state.
      * @return A <i>boolean</i> which is <i>true</i> if the collection has been saved.
@@ -1313,13 +1297,4 @@
     }
 
-    /** Method that is called whenever the metadata set collection changes in some way, such as the addition of a new set or the merging of two sets. We want to mark the collection so that it needs saving again.
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
-     * @see org.greenstone.gatherer.collection.Collection
-     */
-    public void setChanged(MSMEvent event) {
-	// Invalidate saved
-	collection.setSaved(false);
-    }
-
     public void setClosingThread(boolean set) {
 	if(set) {
@@ -1331,24 +1306,4 @@
     }
 
-    /** Updates the given workspace tree model to reference the private cache of the currently loaded collection. */
-    /* private void updatePrivateWorkspace(DefaultTreeModel model) {
-	// Add Private workspace if a collection has been loaded.
-	if(ready() && !Configuration.get("workflow.mirror", true)) {
-	    FileNode root = (FileNode)model.getRoot();
-				// Remove old private workspace
-	    FileNode old = (FileNode)model.getChild(root, 2);
-	    model.removeNodeFromParent(old);
-				// Create and insert new.
-	    FileNode private_workspace = new FileNode(new File(getCollectionCache()), Dictionary.get("Tree.Private"));
-	    model.insertNodeInto(private_workspace, root, 2);
-	}
-	} */
-    /** Called whenever the value tree of an metadata element changes in some way, such as the addition of a new value. We want to mark the collection so that it needs saving again.
-     * @param event A <strong>MSMEvent</strong> containing details of the event that caused this message to be fired.
-     * @see org.greenstone.gatherer.collection.Collection
-     */
-    public void valueChanged(MSMEvent event) {
-	collection.setSaved(false);
-    }
 
     /** I started giving the user the choice of using an existing meta set or creating a new one. The second option being so that they didn't have to add/merge/ignore each element, they could all be added automatically. However, I am not sure where the merge prompt gets called from, and it is not essential, so I am leaving it for now - it should be added back in and finished. [kjdon] */
@@ -1364,12 +1319,12 @@
 
 	/*if (meta_choice == ExternalCollectionPrompt.NEW_META_SET) {
-	    NewMetaSetPrompt nmsp = new NewMetaSetPrompt();
-	    if (nmsp.isCancelled()) {
-	    return false;
-}
-	    String namespace_str = nmsp.getNamespace();
-	    String name_str = nmsp.getName();
-	    MetadataSet set = Gatherer.c_man.msm.addSet(namespace_str, name_str);
-	} else if (meta_choice == ExternalCollectionPrompt.EXISTING_META_SET) {
+	  NewMetaSetPrompt nmsp = new NewMetaSetPrompt();
+	  if (nmsp.isCancelled()) {
+	  return false;
+	  }
+	  String namespace_str = nmsp.getNamespace();
+	  String name_str = nmsp.getName();
+	  // MetadataSet set = Gatherer.c_man.msm.addSet(namespace_str, name_str);
+	  } else if (meta_choice == ExternalCollectionPrompt.EXISTING_META_SET) {
 	*/
 	// now we reuse the newcoll metadata prompt for the user to select metadata sets
@@ -1381,28 +1336,14 @@
 	// Import default metadata sets if any.
 	for(int i = 0; metadata_sets != null && i < metadata_sets.size(); i++) {
-	    MetadataSet metadata_set = (MetadataSet) metadata_sets.get(i);
-	    collection.msm.importMDS(metadata_set.getFile(), false);
-	}
-	/*} else {
-	  return false;
-	  }*/
+	    importMetadataSet((MetadataSet) metadata_sets.get(i));
+	}
+
 	// Always import the extracted metadata set
-	collection.msm.importMDS(new File(Utility.METADATA_DIR + Utility.EXTRACTED_METADATA_NAMESPACE + StaticStrings.METADATA_SET_EXTENSION), false);
+	File extracted_metadata_set_file = new File(Utility.METADATA_DIR + Utility.EXTRACTED_METADATA_NAMESPACE + StaticStrings.METADATA_SET_EXTENSION);
+	importMetadataSet(new MetadataSet(extracted_metadata_set_file));
 
 	return true;
     }
 
-
-//      // now try to load in existing metadata, delete the existing metadata.xml files, then save the new ones.
-//      private boolean findAndLoadExistingMetadata(File collection_dir)
-//      {
-//  	TreeModel collection_tree = getRecordSet();
-//  	FileNode root_node = (FileNode) collection_tree.getRoot();
-//  	if (searchForMetadata(collection_tree, root_node) == false) {
-//  	    return false;
-//  	}
-//  	collection.gdm.save(root_node);
-//  	return true;
-//      }
 
     // used as arg in the perl scripts
@@ -1423,9 +1364,11 @@
     }
 
+
     /** Install collection by moving its files from building to index after a successful build.
      * @see org.greenstone.gatherer.Gatherer
      * @see org.greenstone.gatherer.util.Utility
      */
-    private boolean installCollection() {
+    private boolean installCollection()
+    {
 	DebugStream.println("Build complete. Moving files.");
 
@@ -1506,53 +1449,10 @@
 
 
-    private boolean searchArchivesForMetadata(File archive_directory) {
-	/** @todo - ensure GreenstoneArchiveParser works as expected. */
-	return true;
-    }
-
-    /** now this returns true if successful, false if unsuccessful or cancelled */
-    private boolean searchForMetadata(File current_file) {
-	boolean success = true;
-       if(current_file.isFile() && current_file.getName().equals(Utility.METADATA_XML)) {
-           success = collection.msm.searchForMetadata(null, new FileNode(current_file), false, true); // A dummy run only.
-       }
-       else {
-           File[] children_files = current_file.listFiles();
-           for(int i = 0; success && children_files != null && i < children_files.length; i++) {
-               success = searchForMetadata(children_files[i]);
-           }
-       }
-       return success;
-     }
-    
-    private boolean searchForMetadata(TreeModel collection_tree, FileNode current_node) {
-	File source_file = current_node.getFile();
-	String source_file_name = source_file.getName();
-	if (source_file_name.equals(Utility.METADATA_XML) || source_file_name.equals("CVS")) {
-	    return true;
-	}
-	if (collection.msm.searchForMetadata(current_node, current_node, false)== false) {
-	    return false;
-	}
-	int num_children = collection_tree.getChildCount(current_node);
-	for (int i=0; i<num_children; i++) {
-	    FileNode child = (FileNode)collection_tree.getChild(current_node, i);
-	    if (searchForMetadata(collection_tree, child)==false) {
-		return false;
-	    }
-	}
-	return true;
-    }
-
-    private void updateCollectionCFG(File base_cfg, File new_cfg, String description, String email, String title) {
+    private void updateCollectionCFG(File base_cfg, File new_cfg, String description, String email, String title)
+    {
 	boolean first_name = true;
 	boolean first_extra = true;
 	String collection_path = (base_cfg.getParentFile().getParentFile()).getAbsolutePath();
-	
-	HashMap mappings = collection.msm.profiler.getActions(collection_path);
-	if(mappings == null) {
-	    DebugStream.println("Mappings is null, which is odd. Leaving all configuration commands which use metadata as they are.");
-	}
-	
+
 	// Now read in base_cfg line by line, parsing important onces and/or replacing them with information pertinent to our collection. Each line is then written back out to the new collect.cfg file.
 	try {
@@ -1620,9 +1520,6 @@
 				text.append(token);
 				String temp_metadata = tokenizer.nextToken();
-				String replacement = null;
-				if(mappings != null) {
-				    replacement = (String) mappings.get(temp_metadata);
-				}
-				if(replacement != null) {
+				String replacement = ProfileXMLFileManager.getMetadataElementFor(temp_metadata);
+				if (replacement != null && !replacement.equals("")) {
 				    token = replacement;
 				    old_metadata = temp_metadata;
@@ -1641,9 +1538,6 @@
 				text.append(token);
 				String temp_metadata = tokenizer.nextToken();
-				String replacement = null;
-				if(mappings != null) {
-				    replacement = (String) mappings.get(temp_metadata);
-				}
-				if(replacement != null) {
+				String replacement = ProfileXMLFileManager.getMetadataElementFor(temp_metadata);
+				if (replacement != null && !replacement.equals("")) {
 				    token = replacement;
 				}
@@ -1681,6 +1575,6 @@
 		    old_metadata = null;
 		    write(out, command);
-		 } else {
-		     // the rest of the commands just want a string - we read in all the tokens from the tokeniser and get rid of it.
+		} else {
+		    // the rest of the commands just want a string - we read in all the tokens from the tokeniser and get rid of it.
 		    StringBuffer new_command = new StringBuffer(command_type_str);
 		    while (tokenizer.hasMoreTokens()) {
@@ -1694,18 +1588,22 @@
 		    // we really want to build up the whole command here
 		    boolean format_command = command_type_str.equals(Utility.CFG_FORMAT);
-		    // Replace mapping strings
-		    if(mappings != null) {
-			for(Iterator keys = mappings.keySet().iterator(); keys.hasNext(); ) {
+		    HashMap metadata_mapping = ProfileXMLFileManager.getMetadataMapping();
+		    if (metadata_mapping != null) {
+			Iterator keys = metadata_mapping.keySet().iterator();
+			while (keys.hasNext()) {
 			    String target = (String) keys.next();
-			    String replacement = (String) mappings.get(target);
-			    if(format_command) {
-				target = "\\[" + target + "\\]";
-				replacement = "{Or}{[" + replacement + "]," + target + "}";
+			    String replacement = (String) metadata_mapping.get(target);
+			    if (replacement != null && !replacement.equals("")) {
+				if (format_command) {
+				    target = "\\[" + target + "\\]";
+				    replacement = "{Or}{[" + replacement + "]," + target + "}";
+				}
+				command = command.replaceAll(target, replacement);
 			    }
-			    command = command.replaceAll(target, replacement);
 			}
 		    }
+
 		    write(out, command);
-		 }
+		}
 		tokenizer = null;
 	    }
@@ -1727,4 +1625,5 @@
 	out.newLine();
     }
+
 
     /** The CollectionManager class is getting too confusing by half so I'll implement this TreeModelListener in a private class to make responsibility clear. */
Index: /trunk/gli/src/org/greenstone/gatherer/collection/LegacyCollectionImporter.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/collection/LegacyCollectionImporter.java	(revision 8313)
+++ /trunk/gli/src/org/greenstone/gatherer/collection/LegacyCollectionImporter.java	(revision 8313)
@@ -0,0 +1,138 @@
+package org.greenstone.gatherer.collection;
+
+
+import java.io.*;
+import org.greenstone.gatherer.DebugStream;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.Argument;
+import org.greenstone.gatherer.cdm.Classifier;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataTools;
+import org.greenstone.gatherer.metadata.ProfileXMLFileManager;
+import org.greenstone.gatherer.util.StaticStrings;
+import org.greenstone.gatherer.util.Utility;
+
+
+/**
+ * Importing legacy collections involves two main steps:
+ *
+ * 1. Read the existing metadata.xml files and namespace them, usually by prompting the user
+ *    to specify the mapping between old metadata elements and new elements.
+ *
+ * 2. Fix up the classify commands in the collect.cfg file to specify the new element names.
+ *
+ * @author Michael Dewsnip
+ */
+public class LegacyCollectionImporter 
+{
+    // This copies all the existing metadata.xml files into a backup directory
+    static public void backupMetadataXMLFiles(File collection_dir)
+    {
+	File import_dir = new File(collection_dir, Utility.IMPORT_DIR);
+	File import_bak_dir = new File(collection_dir, Utility.IMPORT_BAK_DIR);
+	import_bak_dir.mkdir();
+	copyMetadataXMLFiles(import_dir, import_bak_dir);
+    }
+
+
+    static private void copyMetadataXMLFiles(File source_dir, File backup_dir)
+    {
+	if (source_dir == null || !source_dir.exists()) {
+	    return;
+	}
+
+	// Find the metadata file in this dir
+	File metadata_xml_file_file = new File(source_dir, "metadata.xml");
+	if (metadata_xml_file_file.exists()) {
+	    File new_metadata_xml_file_file = new File(backup_dir, "metadata.xml");
+	    try {
+		backup_dir.mkdirs();
+		Gatherer.f_man.getQueue().copyFile(metadata_xml_file_file, new_metadata_xml_file_file, null);
+		if (!new_metadata_xml_file_file.exists()) {
+		    throw new Exception("");
+		}
+	    }
+	    catch (Exception e) {
+		DebugStream.println("Exception: couldn't copy the file " + metadata_xml_file_file.getPath() + e.getMessage());
+	    }
+	}
+
+	// Now go through child directories
+	File [] children = source_dir.listFiles();
+	for (int i = 0; i < children.length; i++) {
+	    File child = children[i];
+	    if (child.isDirectory()) {
+		copyMetadataXMLFiles(child, new File(backup_dir, child.getName()));
+	    }
+	}
+    }
+
+
+    static public void updateClassifiers(CollectionDesignManager cdm)
+    {
+	// Update the metadata elements in each of the classifiers
+	for (int i = 0; i < cdm.classifier_manager.getSize(); i++) {
+	    Classifier classifier = cdm.classifier_manager.getClassifier(i);
+	    // System.err.println("Classifier: " + classifier);
+
+	    // Update the "-metadata" value
+	    Argument metadata_argument = classifier.getArgument("-metadata");
+	    String metadata_argument_value = metadata_argument.getValue();
+	    String metadata_element_name_full = mapLegacyMetadataElementName(metadata_argument_value);
+	    if (metadata_element_name_full != null && !metadata_element_name_full.equals("")) {
+		String metadata_element_display_name_full = MetadataTools.getDisplayNameForMetadataElementWithName(metadata_element_name_full);
+		if (metadata_element_display_name_full != null) {
+		    metadata_argument_value = metadata_element_display_name_full;
+		    metadata_argument.setValue(metadata_argument_value);
+		}
+	    }
+
+  	    // Update the "-sort" value
+	    Argument sort_argument = classifier.getArgument("-sort");
+	    if (sort_argument != null) {
+		String sort_element_name_full = mapLegacyMetadataElementName(sort_argument.getValue());
+		if (sort_element_name_full != null && !sort_element_name_full.equals("")) {
+		    String sort_element_display_name_full = MetadataTools.getDisplayNameForMetadataElementWithName(sort_element_name_full);
+		    if (sort_element_display_name_full != null) {
+			sort_argument.setValue(sort_element_display_name_full);
+		    }
+		}
+	    }
+
+	    // Set the "-buttonname" value if it isn't already set
+	    Argument buttonname_argument = classifier.getArgument("-buttonname");
+	    if (buttonname_argument.getValue().equals("")) {
+		int namespace_index = metadata_argument_value.indexOf(".");
+		if (namespace_index != -1) {
+		    buttonname_argument.setValue(metadata_argument_value.substring(namespace_index + 1));
+		}
+		else {
+		    buttonname_argument.setValue(metadata_argument_value);
+		}
+		buttonname_argument.setAssigned(true);
+	    }
+
+	    // With Hierarchy classifiers, update the hfile arguments
+  	    if (classifier.getName().equalsIgnoreCase(StaticStrings.HIERARCHY_CLASSIFIER)) {
+		// Update the "-hfile" value
+		Argument hfile_argument = classifier.getArgument(StaticStrings.HFILE_ARGUMENT);
+		hfile_argument.setValue(metadata_element_name_full + ".txt");
+  	    }
+
+	    // System.err.println("Classifier (after): " + classifier);
+	}
+    }
+
+
+    static private String mapLegacyMetadataElementName(String metadata_element_name)
+    {
+ 	// Remove the extracted namespace if it has been added
+ 	if (metadata_element_name.startsWith(StaticStrings.EXTRACTED_NAMESPACE)) {
+ 	    metadata_element_name = metadata_element_name.substring(StaticStrings.EXTRACTED_NAMESPACE.length());
+ 	}
+
+ 	// Update the metadata value to the new (namespaced) one
+	return ProfileXMLFileManager.getMetadataElementFor(metadata_element_name);
+    }
+}
Index: /trunk/gli/src/org/greenstone/gatherer/collection/SaveCollectionTask.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/collection/SaveCollectionTask.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/collection/SaveCollectionTask.java	(revision 8313)
@@ -43,4 +43,5 @@
 import org.greenstone.gatherer.DebugStream;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
 import org.greenstone.gatherer.util.Utility;
 
@@ -66,6 +67,4 @@
     static final private int COPY_COLLECTION      = 4;
     static final private int MAKE_COLLECTION      = 5;
-    static final private int METADATA_SAVED       = 6;
-    static final private int METADATA_XML_SAVED   = 7;
     static final private int OPEN_COLLECTION      = 8;
     static final private int RESTORE_COLLECTION   = 9;
@@ -112,5 +111,5 @@
 	// spd.setMillisToDecideToPopup(100);
 	// spd.setMillisToPopup(100);
-	// 0. Force all remaining metadata.xml files to load.
+
 	// 1. Perform a regular collection save on what we will later refer to as the origin collection.
 	///ystem.err.println("1. Save origin.");
@@ -119,10 +118,4 @@
 	args[0] = collection.getName() + ".col";
 	try {
-	    // Block until all of the metadata files have been read in.
-	    collection.gdm.waitUntilComplete();
-	    // Write out the metadata xml files. The destroy below is meant to do this, but never does.
-	    collection.gdm.save();
-	    // spd.setProgress(getValue(METADATA_XML_SAVED));
-
 	    File file = new File(tmp_loc);
 	    // Create backup
@@ -131,5 +124,5 @@
 		backup.deleteOnExit();
 		if(!file.renameTo(backup)) {
-		    DebugStream.println("Error in CollectionManager.load(): FileRenamedException");
+		    DebugStream.println("Error in SaveCollectionTask.run(): FileRenamedException");
 		}
 	    }
@@ -143,7 +136,6 @@
 	    // spd.setProgress(getValue(COLLECTION_CFG_SAVED));
 
-	    // Write out the metadata files.
-	    Gatherer.c_man.msm.save();
-	    // spd.setProgress(getValue(METADATA_SAVED));
+	    // Write hfiles for the loaded metadata elements into the collection "etc" directory
+	    MetadataSetManager.writeHierarchyFiles(new File(Gatherer.c_man.getCollectionEtc()));
 
 	    collection.setSaved(true);
@@ -307,6 +299,4 @@
 	    return (int)((double)70 * multiplier);
 	case COLLECTION_CFG_SAVED:
-	case METADATA_SAVED:
-	case METADATA_XML_SAVED:
 	    return (int)((double)10 * multiplier);
 	    // Save As
@@ -325,7 +315,2 @@
     }
 }
-
-
-
-
-
Index: /trunk/gli/src/org/greenstone/gatherer/file/FileQueue.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/file/FileQueue.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/file/FileQueue.java	(revision 8313)
@@ -38,4 +38,6 @@
 import org.greenstone.gatherer.gui.LongProgressBar;
 import org.greenstone.gatherer.gui.tree.DragTree;
+import org.greenstone.gatherer.metadata.MetadataValue;
+import org.greenstone.gatherer.metadata.MetadataXMLFileManager;
 import org.greenstone.gatherer.util.ArrayTools;
 import org.greenstone.gatherer.util.DragComponent;
@@ -397,9 +399,7 @@
 					    if(job.type == FileJob.COPY) {
 						// A copy is undone with a delete, so it doesn't really matter where the file originally came from (we're not moving it back there, but into the recycle bin). You may also notice we don't make use of the target parent record. This is because no undo action needs this information, and even if it did it could simply ask for records parent!
-						// Gatherer.c_man.undo.addUndo(job.ID(), UndoManager.FILE_COPY, null, null, job.target, directory_record, job.undo);
 					    }
 					    else {
 						// Movements however do need a source and source parent so the file can be moved back to the correct place.
-						// Gatherer.c_man.undo.addUndo(job.ID(), UndoManager.FILE_MOVE, job.source, (FileNode)origin_node.getParent(), job.target, directory_record, job.undo);
 					    }
 					}
@@ -431,33 +431,31 @@
 				    // Show warning.
 				    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.File_Not_Found_Message", source_file.getName()), Dictionary.get("FileActions.File_Not_Found_Title"), JOptionPane.ERROR_MESSAGE);
-				// Force refresh of source folder.
+				    // Force refresh of source folder.
 				    source_model.refresh(new TreePath(((FileNode)origin_node.getParent()).getPath()));
 				}
 				
 				// We can't have been cancelled, and we must have created a new FileNode during the above phase, before we can handle metadata.
-				if(!cancel_action && new_node != null) {
-				/* Time to handle any existing metadata. */
-				// If the directory came from inside our collection...
+				if (!cancel_action && new_node != null) {
+				    /* Time to handle any existing metadata. */
+				    // If the directory came from inside our collection...
 				    if (job.source.toString().equals("Collection")) {
-					///ystem.err.println("Move within collection...");
-					// we just retrieve the metadata attached to the origin node...
-					ArrayList existing_metadata = Gatherer.c_man.getCollection().gdm.getMetadataOnly(source_file);
-					///atherer.println("Existing metadata for " + origin_node + ": " + gdm.toString(existing_metadata));
-					// then assign this remainder to the new folder.
-					///ystem.err.println("New metadata: " + gdm.toString(existing_metadata));
-					Gatherer.c_man.getCollection().gdm.addMetadata(new_node, existing_metadata);
-					existing_metadata = null;
-				    }
-				// If it came from the recycle bin retrieve the metadata from there, once again remembering to account for inherited metadata
-//  				    else if (job.source.toString().equals("Undo")) {
-//  					// Retrieve metadata from the recycle bin
-//  					ArrayList existing_metadata = Gatherer.c_man.undo.getMetadata(source_file);
-//  					// then assign this remainder to the new folder.
-//  					Gatherer.c_man.getCollection().gdm.addMetadata(new_node, existing_metadata);
-//  					existing_metadata = null;
-//  				    }
-				// Otherwise if it came from the workspace use the MSMs parsers to search for folder level metadata (such as metadata.xml or marc records).
+					// System.err.println("Move within collection...");
+
+					// Get the non-folder level metadata assigned to the origin node...
+					ArrayList assigned_metadata = MetadataXMLFileManager.getMetadataAssignedDirectlyToFile(source_file);
+					// ...and remove it from the original node and assign it to the new folder
+					for (int i = 0; i < assigned_metadata.size(); i++) {
+					    MetadataValue metadata_value = (MetadataValue) assigned_metadata.get(i);
+					    MetadataXMLFileManager.removeMetadata(origin_node, metadata_value);
+					    MetadataXMLFileManager.addMetadata(new_node, metadata_value);
+					}
+				    }
+				    // If it came from the workspace search for metadata assigned to the file
 				    else if (job.source.toString().equals("Workspace")) {
-					cancel_action = !Gatherer.c_man.getCollection().msm.searchForMetadata(new_node, origin_node, job.folder_level);
+					ArrayList assigned_metadata = MetadataXMLFileManager.getMetadataAssignedDirectlyToExternalFile(origin_node.getFile());
+					for (int i = 0; i < assigned_metadata.size(); i++) {
+					    MetadataValue metadata_value = (MetadataValue) assigned_metadata.get(i);
+					    MetadataXMLFileManager.addMetadata(new_node, metadata_value);
+					}	
 				    }
 				}
@@ -475,39 +473,33 @@
 			}
 
-			// If the source is an empty directory or a file. Don't do anything to the root node of a tree.
+			// If the source is a file or an empty directory (but not the root node of a tree)
 			File[] child_list = source_file.listFiles();
-			if(source_file.isFile() || (child_list != null && (child_list.length == 0 || (child_list.length == 1 && child_list[0].getName().equals(Utility.METADATA_XML))) && origin_node.getParent() != null)) {
-			    ///atherer.println("File or empty directory.");
-			    // Delete any metadata.xml still in the directory.
-			    if(child_list != null && child_list.length == 1) {
-				child_list[0].delete();
-			    }
-
-			    ///atherer.println("Origin is file or is directory and is empty.");
-			    // update status area
+			if (source_file.isFile() || (child_list != null && child_list.length == 0 && origin_node.getParent() != null)) {
+			    // System.err.println("Deleting file: " + source_file.getAbsolutePath());
+
+			    // Update status area
 			    String args[] = new String[1];
-			    // args[0] = "" + (queue.size() + 1) + "";
 			    args[0] = Utility.formatPath("FileActions.Deleting", source_file.getAbsolutePath(), file_status.getSize().width);
 			    file_status.setText(Dictionary.get("FileActions.Deleting", args));
-			    args = null;
-
-			    // Remove its metadata
-			    ArrayList metadatum = null;
-//  			    if(job.source == Gatherer.c_man.undo) {
-//  				Gatherer.c_man.undo.addMetadata(target_file, metadatum);
-//  			    }
-//  			    else {
-			    metadatum = Gatherer.c_man.getCollection().gdm.removeMetadata(origin_node.getFile());
-				// }
-			    // determine its parent node
-			    FileNode parent_record = (FileNode)origin_node.getParent();
+
+			    // If it is a metadata.xml file, we must unload it
+			    if (source_file.getName().equals(Utility.METADATA_XML)) {
+				MetadataXMLFileManager.unloadMetadataXMLFile(source_file);
+			    }
+
+			    // Remove the metadata assigned directly to the file
+			    ArrayList assigned_metadata = MetadataXMLFileManager.getMetadataAssignedDirectlyToFile(origin_node.getFile());
+			    for (int i = 0; i < assigned_metadata.size(); i++) {
+				MetadataValue metadata_value = (MetadataValue) assigned_metadata.get(i);
+				MetadataXMLFileManager.removeMetadata(origin_node, metadata_value);
+ 			    }
+
 			    // Remove from model
-			    if(parent_record != null) {
+			    FileNode parent_record = (FileNode) origin_node.getParent();
+			    if (parent_record != null) {
 				SynchronizedTreeModelTools.removeNodeFromParent(source_model, origin_node);
 			    }
-			    // If we are deleting
-			    File recycled_file = null;
-			    FileNode recycled_parent = null;
-			    // delete the source file
+
+			    // Delete the source file
 			    Utility.delete(source_file);
 			}
